=== debian/changelog ===
gudhi (2.2.0+dfsg-2ubuntu1) cosmic; urgency=medium

  * Override dh_auto_build-arch too, to fix FTBFS on arch-only builds.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Aug 2018 02:41:05 +0100

gudhi (2.2.0+dfsg-2) unstable; urgency=medium

  * Build Python bindings for all supported Python (3) versions.
  * Drop patch forcing Python 3 detection. Upstream has cmake option for
    selecting Python version.
  * Standards-version 4.2.0. No changes needed.

 -- Gard Spreemann <gspreemann@gmail.com>  Tue, 07 Aug 2018 13:47:38 +0200

gudhi (2.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Čech complex.
    - New functionality for the Rips complex.
  * Refresh patches:
    - Drop floating point precision workaround patch (fixed upstream).
    - Drop CGAL 4.12 compatibility patch (fixed upstream).
  * Streamline the copyright information a bit.
  * Bump CMake build-dep to 3.1.
  * New upstream utilities in gudhi-utils.

 -- Gard Spreemann <gspreemann@gmail.com>  Fri, 22 Jun 2018 10:12:19 +0200

gudhi (2.1.0+dfsg-3) unstable; urgency=medium

  * Add patch for floating point rounding problem on some architectures.
  * Add patch that forces linking against libatomic. This hopefully fixes
    building on MIPS et al.
  * Install utilities (gudhi-utils).

 -- Gard Spreemann <gspreemann@gmail.com>  Thu, 14 Jun 2018 20:07:51 +0200

gudhi (2.1.0+dfsg-2) unstable; urgency=medium

  * Add patches for CGAL 4.12 compatibility.
  * Bump standards-version to 4.1.4. No changes needed.

 -- Gard Spreemann <gspreemann@gmail.com>  Thu, 24 May 2018 11:46:12 +0200

gudhi (2.1.0+dfsg-1) unstable; urgency=medium

  * Initial packaging. (Closes: #840686)

 -- Gard Spreemann <gspreemann@gmail.com>  Sun, 25 Mar 2018 23:52:14 +0200
