=== debian/control ===
Source: gudhi
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gard Spreemann <gspreemann@gmail.com>
Section: math
Priority: optional
Standards-Version: 4.2.0
Build-Depends: cmake (>= 3.1),
               cython3,
               debhelper (>= 11),
               dh-python,
               libboost-chrono-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-timer-dev,
               libcgal-dev (>> 4.11.0),
               libcgal-qt5-dev (>> 4.11.0),
               libeigen3-dev,
               libgmp-dev,
               libqglviewer-dev-qt5,
               libtbb-dev,
               python3-all-dev,
               python3-matplotlib,
               python3-pytest,
               python3-tk,
               qtbase5-dev
Build-Depends-Indep: doxygen,
                     graphviz
Homepage: http://gudhi.gforge.inria.fr/
Vcs-Browser: https://git.nonempty.org/debian-gudhi
Vcs-Git: https://git.nonempty.org/debian-gudhi -b debian/sid

Package: libgudhi-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: libboost-chrono-dev (>= 1.48),
         libboost-filesystem-dev (>= 1.48),
         libboost-program-options-dev (>= 1.48),
         libboost-system-dev (>= 1.48),
         libboost-test-dev (>= 1.48),
         libboost-timer-dev (>= 1.48),
         libcgal-dev (>> 4.11.0),
         libeigen3-dev (>= 3.1.0),
         libgmp-dev (>= 4.2),
         libtbb-dev,
         ${misc:Depends}
Suggests: libgudhi-doc, libgudhi-examples
Description: Generic open source C++ library for topological data analysis
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains the header files. See the libgudhi-examples
 package for example programs using the library.

Package: libgudhi-examples
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libgudhi-dev, libgudhi-doc
Description: Example programs for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains some source code examples.

Package: libgudhi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax, ${misc:Depends}
Description: Documentation for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains documentation.

Package: python3-gudhi
Section: python
Architecture: any
Multi-Arch: same
Depends: python3-matplotlib,
         python3-tk,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python 3 interface to the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains GUDHI's Python (3) interface.

Package: gudhui
Section: math
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GUI for some of the functionality of the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains GudhUI, a graphical interface to a few of GUDHI's
 features. Be aware that it is quite rough around the edges.

Package: gudhi-utils
Section: math
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utilities from the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains some utilities built with the GUDHI library.
