=== debian/tests/control ===
Tests: python-upstream
Depends: python3-gudhi, python3-pytest
