=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg(\.\d+)?$//,filenamemangle=s/\S+\/v?(\S+)\.tar\.gz/gudhi-$1\.tar\.gz/" \
   https://gforge.inria.fr/frs/?group_id=3865 \
   .*\/.*GUDHI_(\d[\d.-]*)\.tar\.gz
